// (C) Copyright 1994 by Borland International
//
// Cmdlg.c - Common Dialogs example in C

/*********************************************************************
- The assembler LYXASS creates absoluted based programs with following header:

	dc.w $8008	; BRA *+8
	dc.w Start
	dc.w Len	; _with_ Header
	dc.l "BS93"

	LYXASS is a 68ooo-Program:
	- WORD is MSB, LSB
	- LONG is MSB, .., .., LSB

- The ComLynx-Loader wants :

start-sequence :	$81,"P"						; command : load program
init-sequence  :	HI(Start), LO(Start)		; start address = dest.
						HI(Len-10 XOR $FFFF), LO(LEN-10 XOR $FFFF)	; Filelength

Xmit-sequence  : ....		; data
checksum       : none at all !!
***********************************************************************/

#include <windowsx.h>
// Contains the necessary headers and definitions for this program
#include "pc2lynx.h"

/***  Global Variables  ***/
char szFileName[256];
BYTE slen_hi,slen_lo,start_hi,start_lo;
HWND hWndStaticStart, hWndEditStart;
HWND hWndStaticLength, hWndEditLength;
HWND hWndStaticBytesLeft, hWndEditBytesLeft;
HWND hWndStaticType, hWndEditType;

HINSTANCE hInst;  // current instance
HANDLE hAccel;		// Accelerator table
HWND hWnd;			// the main window

BYTE FAR *pBuffer;	// The buffer where the file is loaded into
BYTE FAR *pDataBuffer;	// The actual pointer to LYNX-prg.
int idComDev;
WORD	wRealFileLength;
HGLOBAL	hBuffer;


void ShowError(int nError, LPCSTR szError)
{
	char	szOut[200];
	wsprintf(szOut, "%s %d", szError, nError);
	MessageBox(GetActiveWindow(), szOut, "Error!", MB_OK);
}

/*
	send one byte to serial port
*/
void SendByte(int id, BYTE b)
{
	int i, nRet;
	BYTE	bIn;

	while (0 != (nRet = GetCommError(id, NULL)))
		;
	nRet = TransmitCommChar(id, b);	// send the Byte
	while (1 !=  ReadComm(id, &bIn,1))
		;		// Wait till Byte is echoed	?!?
}

void SendFile(HWND hWnd)
{
	int	nComPort;
   int   nBaudrate;

	int err;
	DCB dcb;		/// device control block
	char	szOut[30];

	UINT	EventMask;

	// An seriellen Port bergeben...
	nComPort =  GetProfileInt("PC2LYNX", "COMPORT", 2);
	wsprintf(szOut, "COM%d", nComPort);

	// get the baudrate
	nBaudrate =  GetProfileInt("PC2LYNX", "BAUDRATE", 9600);

	idComDev = OpenComm(szOut, (UINT) 2048, (UINT) 2048);
	if (idComDev < 0)
		{
		ShowError(idComDev, "OpenComm");
		}
	else
		{
		FlushComm(idComDev,0);		// Transmission queue
		FlushComm(idComDev,1);		// Receiving queue
		wsprintf(szOut, "COM%d:%u,e,8,1", nComPort, nBaudrate);  // DO, 25.06.98
      //MessageBox(hWnd, szOut, "COMDCB", MB_OK);
		err = BuildCommDCB(szOut, &dcb);
		if (err < 0)
			{
			ShowError(err, "BuildCommDCB");
			}
		else
			{
			err = SetCommState(&dcb);
			if (err < 0)
				{
				ShowError(err, "SetCommState");
				}
			else
				{
				//... Hier bertragen
				SendByte(idComDev, 0x81);
				SendByte(idComDev, 'P');

				SendByte(idComDev, start_hi);
				SendByte(idComDev, start_lo);

				SendByte(idComDev, slen_hi^0xff);
				SendByte(idComDev, slen_lo^0xff);

				if (wRealFileLength < 2048)
					{
					err = WriteComm(idComDev, pDataBuffer, wRealFileLength);
					wRealFileLength = 0;
					CloseComm(idComDev);	// Close port after transmission
					}
				else
					{
					EventMask = GetCommEventMask(idComDev, EV_TXEMPTY);
					if (EnableCommNotification(idComDev, hWnd, -1, 1024))	// Request a Message
						{
						// We have to split it into several pieces
						err = WriteComm(idComDev, pDataBuffer, 2048);
						pDataBuffer += 2048;
						wRealFileLength -= 2048;
						}
					}
				wsprintf(szOut, "%u", wRealFileLength);
				SetWindowText(hWndEditBytesLeft, szOut);
				UpdateWindow(hWndEditBytesLeft);
				}	// SetCommState
			}	// BuildDCB
		} // OpenComm
}

void LoadFile(HWND hWnd)
{
	HCURSOR	hcurSave;
	HFILE hfReadFile;
	int	nRet;

	WORD	wStartAdr;

	char	szOut[300];

	hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));

	SetWindowText(hWndEditStart, "");
	SetWindowText(hWndEditLength, "");
	SetWindowText(hWndEditBytesLeft, "");
	SetWindowText(hWndEditType, "");
	UpdateWindow(hWnd);

	/* Open the input file (read only). */
	hfReadFile = _lopen(szFileName, READ);

	if (hfReadFile == HFILE_ERROR)
		{
		ShowError(-1, "_lopen");
		}
	else
		{
		wRealFileLength = _llseek(hfReadFile, 0L, 2);	// Get the real filelength
		_llseek(hfReadFile, 0, 0);
		nRet = _lread(hfReadFile, pBuffer, wRealFileLength);
		if (nRet == HFILE_ERROR)
			ShowError(nRet, "_lread() failed!");
		else
			{
			_lclose(hfReadFile);
			//  WORDs and LONG are in the Motorola 68ooo-format!
			if (*(pBuffer) == 0x80 &&  *(pBuffer+1)== 0x08)		// 6502-command Bra *+8 --> $8008
				{	// LYX_ASS-File
				start_hi = *(pBuffer+2);
				start_lo = *(pBuffer+3);
				wRealFileLength -= 10;
				slen_hi  = wRealFileLength>>8;
				slen_lo  = wRealFileLength & 0x00ff;

				wStartAdr = (start_hi<<8) | start_lo;
				//wsprintf(szOut, "*.O file detetcted: \nMagic BRA *+8 found!\nStartaddress: %#x\nReal Filelength: HEX: %#x, DEZ: %u", wStartAdr, wRealFileLength, wRealFileLength);
				//MessageBox(GetActiveWindow(), szOut, "Parameters:", MB_OK);
				wsprintf(szOut, "%#x", wStartAdr);
				SetWindowText(hWndEditStart, szOut);
				wsprintf(szOut, "%u", wRealFileLength);
				SetWindowText(hWndEditLength, szOut);
				wsprintf(szOut, "%u", wRealFileLength);
				SetWindowText(hWndEditBytesLeft, szOut);

				SetWindowText(hWndEditType, "*.O");
				UpdateWindow(hWnd);

				//pBuffer += 10;		// Skip this Header
				pDataBuffer = pBuffer + 10; // New

				SendFile(hWnd);
				}
			else if (*(pBuffer) == 0xff &&  *(pBuffer+1)== 0xff)
				{	 // *.com file
				start_hi = *(pBuffer+3);
				start_lo = *(pBuffer+2);
				wRealFileLength -= 6;
				slen_hi  = wRealFileLength>>8;
				slen_lo  = wRealFileLength & 0x00ff;

				wStartAdr = (start_hi<<8) | start_lo;
				//wsprintf(szOut, "*.COM file detected: \nMagic 0xffff found!\nStartaddress: %#x\nReal Filelength: HEX: %#x, DEZ: %u", wStartAdr, wRealFileLength, wRealFileLength);
				//MessageBox(GetActiveWindow(), szOut, "Parameters:", MB_OK);
				wsprintf(szOut, "%#x", wStartAdr);
				SetWindowText(hWndEditStart, szOut);
				wsprintf(szOut, "%u", wRealFileLength);
				SetWindowText(hWndEditLength, szOut);
				wsprintf(szOut, "%u", wRealFileLength);
				SetWindowText(hWndEditBytesLeft, szOut);

				SetWindowText(hWndEditType, "*.COM");
				UpdateWindow(hWnd);

				//pBuffer += 6;		// Skip this Header
				pDataBuffer = pBuffer + 6;

				SendFile(hWnd);
				}
			else
				MessageBox(GetActiveWindow(), "Neither *.O nor *.COM file!", "Error", MB_OK);
			} // _lread
		} // hfReadFile != HFILE_ERROR

	SetCursor(hcurSave);
}

/*********************************************************************
Using the OPENFILENAME structure and the Windows API call GetOpenFileName()
eases the selection of files for the programmer and for the user.  The
help file WIN31WH.HLP (found in the \BC5\HELP directory) contains a
detailed description of the function call and its associated structure.
The Flags field of the structure is particularly useful when
customization is required.
**********************************************************************/
BOOL CMUFileOpen( HWND hWnd )
{
	int	nRet;
	OPENFILENAME ofnTemp;
	DWORD	Errval; // Error value
	char	buf[5];  // Error buffer
	char	Errstr[50]="GetOpenFileName returned Error #";
	char	szTemp[] = "LYNX Files (*.o;*.com)\0*.o;*.com\0All Files (*.*)\0*.*\0";
	char	szPath[200];

  GetProfileString("PC2LYNX", "PATH", "", szPath, 200);

/*
Note the initialization method of the above string.  The GetOpenFileName()
function expects to find a string in the OPENFILENAME structure that has
a '\0' terminator between strings and an extra '\0' that terminates the
entire filter data set.  Using the technique shown below will fail because
"X" is really 'X' '\0' '\0' '\0' in memory.  When the GetOpenFileName()
function scans szTemp it will stop after finding the extra trailing '\0'
characters.

  char szTemp[][4] = { "X", "*.*", "ABC", "*.*", "" };

The string should be "X\0*.*\0ABC\0*.*\0".

Remember that in C or C++ a quoted string is automatically terminated with
a '\0' character so   char "X\0";   would result in 'X' '\0' '\0' which
provides the extra '\0' that GetOpenFileName() needs to see in order to
terminate the scan of the string.  Just 'char ch "X";' would result in 'X'
'\0' and GetOpenFileName() would wander off in memory until it lucked into
a '\0' '\0' character sequence.
*/

/*
Some Windows structures require the size of themselves in an effort to
provide backward compatibility with future versions of Windows.  If the
lStructSize member is not set the call to GetOpenFileName() will fail.
*/
  ofnTemp.lStructSize = sizeof( OPENFILENAME );
  ofnTemp.hwndOwner = hWnd; // An invalid hWnd causes non-modality
  ofnTemp.hInstance = 0;
  ofnTemp.lpstrFilter = (LPSTR)szTemp;  // See previous note concerning string
  ofnTemp.lpstrCustomFilter = NULL;
  ofnTemp.nMaxCustFilter = 0;
  ofnTemp.nFilterIndex = 1;
  ofnTemp.lpstrFile = (LPSTR)szFileName;  // Stores the result in this variable
  ofnTemp.nMaxFile = sizeof( szFileName );
  ofnTemp.lpstrFileTitle = NULL;
  ofnTemp.nMaxFileTitle = 0;
  ofnTemp.lpstrInitialDir = szPath;
  ofnTemp.lpstrTitle = "Open";  // Title for dialog
  ofnTemp.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
  ofnTemp.nFileOffset = 0;
  ofnTemp.nFileExtension = 0;
  ofnTemp.lpstrDefExt = "o";
  ofnTemp.lCustData = 0L;
  ofnTemp.lpfnHook = NULL;
  ofnTemp.lpTemplateName = NULL;
/*
If the call to GetOpenFileName() fails you can call CommDlgExtendedError()
to retrieve the type of error that occured.
*/
	if(GetOpenFileName( &ofnTemp ) == TRUE)
		{
		nRet = TRUE;
		}
	else	//*************************************************
		{
		nRet = FALSE;
		Errval=CommDlgExtendedError();
		if(Errval!=0) // 0 value means user selected Cancel
			{
			wsprintf(buf,"%ld",Errval);
			strcat(Errstr,buf);
			MessageBox(hWnd,Errstr,"WARNING",MB_OK|MB_ICONSTOP);
			}
		}
	return nRet;
}


/**********************************************************************/
BOOL InitApplication(HINSTANCE hInstance)
{
  WNDCLASS  wc;

  // Fill in window class structure with parameters that describe the
  // main window.

  wc.style = CS_HREDRAW | CS_VREDRAW; // Class style(s).
  wc.lpfnWndProc = (long (FAR PASCAL*)())MainWndProc; // Function to retrieve messages for
									 // windows of this class.
  wc.cbClsExtra = 0;  // No per-class extra data.
  wc.cbWndExtra = 0;  // No per-window extra data.
  wc.hInstance = hInstance; // Application that owns the class.
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockObject(WHITE_BRUSH);
  wc.lpszMenuName = "CMDLGAPMENU";  // Name of menu resource in .RC file.
  wc.lpszClassName = "CMDLG"; // Name used in call to CreateWindow.

  /* Register the window class and return success/failure code. */

  return (RegisterClass(&wc));

}


/************************************************************************/
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
  /* Save the instance handle in static variable, which will be used in  */
  /* many subsequence calls from this application to Windows.            */

  hInst = hInstance;

  // Load the accelerator table
  hAccel = LoadAccelerators( hInstance,	"CMDLGAPMENU" );

  /* Create a main window for this application instance.  */

  hWnd = CreateWindow(
	 "CMDLG",                 // See RegisterClass() call.
	 "PC to Lynx",  // Text for window title bar.
	 WS_OVERLAPPEDWINDOW,        // Window style.
	 CW_USEDEFAULT,         // Default horizontal position.
	 CW_USEDEFAULT,          // Default vertical position.
	 CW_USEDEFAULT,            // Default width.
	 CW_USEDEFAULT,        // Default height.
	 NULL,                  // Overlapped windows have no parent.
	 NULL,                  // Use the window class menu.
	 hInstance,              // This instance owns this window.
	 NULL                   // Pointer not needed.
  );

  /* If window could not be created, return "failure" */

  if (!hWnd)
	 return (FALSE);

  /* Make the window visible; update its client area; and return "success" */

  ShowWindow(hWnd, nCmdShow); // Show the window
  UpdateWindow(hWnd);     // Sends WM_PAINT message
  return (TRUE);        // Returns the value from PostQuitMessage

}


/****************************************************************************
  FUNCTION: MainWndProc(HWND, UINT, WPARAM, LPARAM)
****************************************************************************/
LRESULT FAR PASCAL _export MainWndProc(HWND hWnd, UINT message,
						WPARAM wParam, LPARAM lParam)
{
	RECT	rc;
  HDC	hdc;
  TEXTMETRIC	tm;
  char	szOut[200];
	int err;
	UINT	EventMask;

  switch (message) {
  case WM_CREATE: // Initialize Global vars
	{
	hdc = GetDC(hWnd);
	GetTextMetrics(hdc, &tm);
	ReleaseDC(hWnd, hdc);
	hWndStaticStart = CreateWindow("static", "Startaddress", WS_CHILD | WS_VISIBLE | SS_RIGHT, tm.tmAveCharWidth*2, tm.tmHeight*1.25, tm.tmAveCharWidth*12, tm.tmHeight*1.5, hWnd, (HMENU) 1, (HINSTANCE) GetWindowWord(hWnd, GWW_HINSTANCE), NULL);
	hWndEditStart = CreateWindow("edit", NULL, WS_CHILD | WS_VISIBLE | WS_DISABLED | WS_BORDER | ES_RIGHT, tm.tmAveCharWidth*15, tm.tmHeight*1, tm.tmAveCharWidth*10, tm.tmHeight*1.5, hWnd, (HMENU) 2, (HINSTANCE) GetWindowWord(hWnd, GWW_HINSTANCE), NULL);

	hWndStaticLength = CreateWindow("static", "Size", WS_CHILD | WS_VISIBLE | SS_RIGHT, tm.tmAveCharWidth*2, tm.tmHeight*3.25, tm.tmAveCharWidth*12, tm.tmHeight*1.5, hWnd, (HMENU) 3, (HINSTANCE) GetWindowWord(hWnd, GWW_HINSTANCE), NULL);
	hWndEditLength = CreateWindow("edit", NULL, WS_CHILD | WS_VISIBLE | WS_DISABLED | WS_BORDER | ES_RIGHT, tm.tmAveCharWidth*15, tm.tmHeight*3, tm.tmAveCharWidth*10, tm.tmHeight*1.5, hWnd, (HMENU) 4, (HINSTANCE) GetWindowWord(hWnd, GWW_HINSTANCE), NULL);

	hWndStaticBytesLeft = CreateWindow("static", "Bytes left", WS_CHILD | WS_VISIBLE | SS_RIGHT, tm.tmAveCharWidth*2, tm.tmHeight*5.25, tm.tmAveCharWidth*12, tm.tmHeight*1.5, hWnd, (HMENU) 5, (HINSTANCE) GetWindowWord(hWnd, GWW_HINSTANCE), NULL);
	hWndEditBytesLeft = CreateWindow("edit", NULL, WS_CHILD | WS_VISIBLE | WS_DISABLED | WS_BORDER | ES_RIGHT, tm.tmAveCharWidth*15, tm.tmHeight*5, tm.tmAveCharWidth*10, tm.tmHeight*1.5, hWnd, (HMENU) 6, (HINSTANCE) GetWindowWord(hWnd, GWW_HINSTANCE), NULL);

	hWndStaticType = CreateWindow("static", "Type", WS_CHILD | WS_VISIBLE | SS_RIGHT, tm.tmAveCharWidth*2, tm.tmHeight*7.25, tm.tmAveCharWidth*12, tm.tmHeight*1.5, hWnd, (HMENU) 5, (HINSTANCE) GetWindowWord(hWnd, GWW_HINSTANCE), NULL);
	hWndEditType = CreateWindow("edit", NULL, WS_CHILD | WS_VISIBLE | WS_DISABLED | WS_BORDER | ES_RIGHT, tm.tmAveCharWidth*15, tm.tmHeight*7, tm.tmAveCharWidth*10, tm.tmHeight*1.5, hWnd, (HMENU) 6, (HINSTANCE) GetWindowWord(hWnd, GWW_HINSTANCE), NULL);

	GetWindowRect(hWnd, &rc);
	rc.right = 32*tm.tmAveCharWidth;
	rc.bottom = 12*tm.tmHeight;
	MoveWindow(hWnd, rc.left, rc.top, rc.right, rc. bottom, TRUE);

	hBuffer = NULL;
	pBuffer = NULL;
	pDataBuffer = NULL;
	hBuffer = GlobalAlloc(GPTR, 70000L);	// > 64K anlegen
	if (hBuffer)
		{		// Nur sofort starten, wenn Puffer auch da ist!!!
		pBuffer = (BYTE FAR *)GlobalLock(hBuffer);

		if (lstrlen(szFileName))
			LoadFile(hWnd);
		}
	 return 0L;
	}
	break;

	case	WM_COMMNOTIFY:
		if (LOWORD(lParam) == CN_TRANSMIT)
			{
			FlushComm(idComDev,1);		// Receiving queue
			// next piece
			if (wRealFileLength >= 1024)
				{
				//MessageBeep(32);
				// Sorry, i was not able to do this the right way
				EventMask = GetCommEventMask(idComDev, -1);	// Clear all events?
				EnableCommNotification(idComDev, NULL, -1, -1);	// So stop notification
				EnableCommNotification(idComDev, hWnd, -1, 1024); // enable notification

				err = WriteComm(idComDev, pDataBuffer, 1024);
				wRealFileLength -= 1024;
				pDataBuffer += 1024;
				}
			else	// The remaining amount of bytes
				{
				//MessageBeep(32);
				// Not necessary
				EventMask = GetCommEventMask(idComDev, -1);
				EnableCommNotification(idComDev, NULL, -1, -1);
				EnableCommNotification(idComDev, hWnd, -1, 1024);
				err = WriteComm(idComDev, pDataBuffer, wRealFileLength);
				wRealFileLength = 0;
				EnableCommNotification(idComDev, NULL, -1, -1);
				CloseComm(idComDev);
				}

			wsprintf(szOut, "%u", wRealFileLength);
			SetWindowText(hWndEditBytesLeft, szOut);
			UpdateWindow(hWndEditBytesLeft);
			// We have to wait, transfer is done in background
			}
		return 0;

  case WM_COMMAND:  // message: command from application menu
	switch(GET_WM_COMMAND_ID(wParam, lParam))
	 {
		case CM_EXIT:
			 DestroyWindow(hWnd);
		  break;

		case CM_U_FILEOPEN:
			 if (CMUFileOpen(hWnd))
				LoadFile(hWnd);	// If a file was choosen, then send it to the Lynx
		  break;

		case CM_FILERELOAD_AND_SEND_AGAIN:
			if (lstrlen(szFileName))
				LoadFile(hWnd);	// If there was a file sent before, send it again
		  break;

		case CM_U_HELPABOUT:
			 MessageBox(hWnd,szCMDLGAPAbout,"About PC2LYNX",MB_OK);
		  break;

		default:
		  break;
	 }
	 break;

  case WM_QUIT:
  case WM_DESTROY:  // message: window being destroyed
		// destroy buffer
		// CloseComm(idComDev);
		if (hBuffer)
			{
			GlobalUnlock(hBuffer);
			GlobalFree(hBuffer);
			} // if GlobalAlloc()
		PostQuitMessage(0);
	 break;

  default:      // Passes it on if unproccessed
	 return (DefWindowProc(hWnd, message, wParam, lParam));
  }
  return 0L;
}

#pragma argsused
/**************************************************************/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
			  LPSTR lpCmdLine, int nCmdShow)
{
  MSG msg;      // message

  lstrcpy(szFileName, lpCmdLine);		// Drag and Drop?

  if (!hPrevInstance) // Other instances of app running?
  if (!InitApplication(hInstance))  // Initialize shared things
	 return (FALSE); // Exits if unable to initialize

  /* Perform initializations that apply to a specific instance */

  if (!InitInstance(hInstance, nCmdShow))
	 return (FALSE);

  /* Acquire and dispatch messages until a WM_QUIT message is received. */
  while (GetMessage(&msg, // message structure
	 NULL, // handle of window receiving the message
	 0,    // lowest message to examine
	 0))   // highest message to examine
  {
  if ( !TranslateAccelerator( hWnd, hAccel, &msg ))
	  {
	  TranslateMessage(&msg); // Translates virtual key codes
	  DispatchMessage(&msg);  // Dispatches message to window
	  }
	}

  return (msg.wParam);  // Returns the value from PostQuitMessage
}

// End of file cmdlg.c
